------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
private with Ada.Finalization;
with Interfaces.C;
with Qt4.Strings;
with Qt4.Variants;
private with Qt_Ada.Internals.Value_Class_Sizes;
with System;

package Qt4.Sql_Fields is

   --  QSqlField::RequiredStatus

   type Field_Required_Status is
    (Unknown,
     Optional,
     Required);
   pragma Convention (C, Field_Required_Status);
   for Field_Required_Status'Size use Interfaces.C.int'Size;
   for Field_Required_Status use
    (Unknown  => -1,
     Optional =>  0,
     Required =>  1);

   type Q_Sql_Field is tagged private;

   function Create
    (Field_Name : Qt4.Strings.Q_String'Class;
     The_Type : Qt4.Variants.Variant_Type
       := Qt4.Variants.Invalid)
       return Q_Sql_Field;

   procedure Clear
    (Self : in out Q_Sql_Field'Class);

   function Default_Value
    (Self : Q_Sql_Field'Class)
       return Qt4.Variants.Q_Variant;

   function Is_Auto_Value
    (Self : Q_Sql_Field'Class)
       return Boolean;

   function Is_Generated
    (Self : Q_Sql_Field'Class)
       return Boolean;

   function Is_Null
    (Self : Q_Sql_Field'Class)
       return Boolean;

   function Is_Read_Only
    (Self : Q_Sql_Field'Class)
       return Boolean;

   function Is_Valid
    (Self : Q_Sql_Field'Class)
       return Boolean;

   function Length
    (Self : Q_Sql_Field'Class)
       return Qt4.Q_Integer;

   function Name
    (Self : Q_Sql_Field'Class)
       return Qt4.Strings.Q_String;

   function Precision
    (Self : Q_Sql_Field'Class)
       return Qt4.Q_Integer;

   function Required_Status
    (Self : Q_Sql_Field'Class)
       return Field_Required_Status;

   procedure Set_Auto_Value
    (Self : in out Q_Sql_Field'Class;
     Auto_Val : Boolean);

   procedure Set_Default_Value
    (Self : in out Q_Sql_Field'Class;
     Value : Qt4.Variants.Q_Variant'Class);

   procedure Set_Generated
    (Self : in out Q_Sql_Field'Class;
     Gen : Boolean);

   procedure Set_Length
    (Self : in out Q_Sql_Field'Class;
     Field_Length : Qt4.Q_Integer);

   procedure Set_Name
    (Self : in out Q_Sql_Field'Class;
     Name : Qt4.Strings.Q_String'Class);

   procedure Set_Precision
    (Self : in out Q_Sql_Field'Class;
     Precision : Qt4.Q_Integer);

   procedure Set_Read_Only
    (Self : in out Q_Sql_Field'Class;
     Read_Only : Boolean);

   procedure Set_Required
    (Self : in out Q_Sql_Field'Class;
     Required : Boolean);

   procedure Set_Required_Status
    (Self : in out Q_Sql_Field'Class;
     Status : Field_Required_Status);

   procedure Set_Type
    (Self : in out Q_Sql_Field'Class;
     The_Type : Qt4.Variants.Variant_Type);

   procedure Set_Value
    (Self : in out Q_Sql_Field'Class;
     Value : Qt4.Variants.Q_Variant'Class);

   function Field_Type
    (Self : Q_Sql_Field'Class)
       return Qt4.Variants.Variant_Type;

   function Value
    (Self : Q_Sql_Field'Class)
       return Qt4.Variants.Q_Variant;

   overriding function "="
    (Self : Q_Sql_Field;
     Other : Q_Sql_Field)
       return Boolean;

   package Internals is

      type QSqlField is private;

      type QSqlField_Access is access all QSqlField;
      pragma Convention (C, QSqlField_Access);

      function QSqlField_View
       (Item : Q_Sql_Field'Class)
          return QSqlField_Access;
      pragma Inline (QSqlField_View);

      function To_Pointer
       (Address : System.Address)
          return QSqlField_Access;
      pragma Inline (To_Pointer);

      function To_Address
       (Pointer : QSqlField_Access)
          return System.Address;
      pragma Inline (To_Address);

      function Create_Wrapper
       (Item : Internals.QSqlField_Access)
          return Q_Sql_Field;

   private

      type QSqlField is record
         Placeholder : Interfaces.C.char_array (1 .. Qt_Ada.Internals.Value_Class_Sizes.QSqlField_C_Size_Of);
      end record;
      pragma Convention (C, QSqlField);

   end Internals;

private

   type Q_Sql_Field is new Ada.Finalization.Controlled with record
      Storage : aliased Internals.QSqlField;
      Object  : Internals.QSqlField_Access := null;
      Wrapper : Boolean := False;
   end record;

   overriding
   procedure Adjust (Self : in out Q_Sql_Field);

   overriding
   procedure Finalize (Self : in out Q_Sql_Field);

   overriding
   procedure Initialize (Self : in out Q_Sql_Field);

end Qt4.Sql_Fields;
